import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class GUIAdressbuch {

	// ein Adressbuch-Objekt
	Adressbuch adressbuch = new Adressbuch();
	
	// Widgets fr die GUI
	JFrame frame = new JFrame("Adressbuch");

	// JList und JScrollPane
	JList list;
	JScrollPane listScroller;

	// Labels fuer die Textfelder
	JLabel labelVorname  = new JLabel("Vorname:   ");
	JLabel labelNachname = new JLabel("Nachname:");
	JLabel labelTelefon  = new JLabel("Telefon:     ");
	JLabel labelSuchen   = new JLabel("Suchen:");

	// Textfelder
	JTextField fieldVorname = new JTextField(15);
	JTextField fieldNachname = new JTextField(15);
	JTextField fieldTelefon = new JTextField(15);
	JTextField fieldSuchen = new JTextField(20);
	
	// Buttons
	JButton buttonHinzufuegen = new JButton("Kontakt hinzufgen");
	JButton buttonLoeschen = new JButton("Felder lschen");
	JButton buttonEntfernen = new JButton("Kontakt entfernen");
	
	// main ruft nur baueGUI() auf
	public static void main (String[] args) {
		GUIAdressbuch gui = new GUIAdressbuch();
		gui.baueGUI();
	}

	// GUI aufbauen und fuer Events registrieren
	public void baueGUI () {
		// jedes Label mit seinem Textfeld in ein eigenes Panel setzen (FlowLayout)
		JPanel panelVorname = new JPanel();
		panelVorname.add(labelVorname);
		panelVorname.add(fieldVorname);		

		JPanel panelNachname = new JPanel();
		panelNachname.add(labelNachname);
		panelNachname.add(fieldNachname);		
		
		JPanel panelTelefon = new JPanel();		
		panelTelefon.add(labelTelefon);
		panelTelefon.add(fieldTelefon);

		// Panel fuer Buttons "Hinzufuegen" und "Felder loeschen"
		JPanel panelButtons = new JPanel();
		panelButtons.add(buttonHinzufuegen);
		panelButtons.add(buttonLoeschen);
		

		// Panel fuer Suchfeld und Label
		JPanel panelSuchen = new JPanel();
		panelSuchen.add(labelSuchen);
		panelSuchen.add(fieldSuchen);
		
		// Panel mit Boxlayout fr Textfelder und Buttons
		JPanel panelRechts = new JPanel();
		panelRechts.setLayout(new BoxLayout(panelRechts, BoxLayout.Y_AXIS));
		panelRechts.add(panelVorname);
		panelRechts.add(panelNachname);
		panelRechts.add(panelTelefon);
		panelRechts.add(panelButtons);
		

		// JList ist am Anfang leer
		list = new JList();
		list.setVisibleRowCount(10);  // Anzahl sichtbarer Zeilen in der Liste
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		//list.addListSelectionListener(new ListListener());
		
		listScroller = new JScrollPane(list);
		listScroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		listScroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

		// das Adressbuch aus der Datei laden und die Eintraege an die JList uebergeben
		// alternativ kann man auch beim Erzeugen der JList die Eintraege im Konstruktor uebergeben
		adressbuch.adressbuchLaden();
		updateJList(adressbuch.getAdressbuch());

		
		// fuer Events registrieren
		buttonLoeschen.addActionListener(new LoeschenListener());
		buttonHinzufuegen.addActionListener(new HinzufuegenListener());
		buttonEntfernen.addActionListener(new EntfernenListener());
		fieldSuchen.addKeyListener(new SuchenListener());
		frame.addWindowListener(new BeendenListener());
		

		// Panel mit BoxLayout fuer Suchfeld, Liste und "Entfernen"-Button
		Panel panelLinks = new Panel();
		panelLinks.setLayout(new BoxLayout(panelLinks, BoxLayout.Y_AXIS));
		panelLinks.add(panelSuchen);
		panelLinks.add(listScroller);
		panelLinks.add(buttonEntfernen);		
		
		// Panel gesamt nimmt das linke (Suchfeld, Liste) und das rechte Panel auf (Eingabfelder)
		JPanel panelGesamt = new JPanel();
		panelGesamt.add(panelLinks);
		panelGesamt.add(panelRechts);		
		frame.setContentPane(panelGesamt);		

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();  // Groesse des Fensters und der Buttons berechnen lassen
		frame.setVisible(true);
		
		// Eingabefokus setzen, damit die Eingabe beim Vornamen beginnen kann
		fieldVorname.requestFocus();
	}
	
	// der JList Bescheid geben, da sich die Eintraege geaendert haben
	void updateJList (ArrayList<Kontakt> neueEintraege) {
		list.setListData(neueEintraege.toArray());
	}
	
	// jetzt kommen die inneren Klassen fr die Event-Listener
	
	// fuer Button "Felder loeschen"
	class LoeschenListener implements ActionListener {
		public void actionPerformed (ActionEvent event) {			
			fieldVorname.setText("");
			fieldNachname.setText("");
			fieldTelefon.setText("");			
		}
	}
	
	// fuer Button "Hinzufuegen"
	// wenn die Felder nicht leer sind, dann den Kontakt hinzufuegen und JList updaten
	// das Adressbuch prueft, ob der Kontakt bereits vorhanden ist
	class HinzufuegenListener implements ActionListener {
		public void actionPerformed (ActionEvent event) {
			String vname = fieldVorname.getText();
			String nname = fieldNachname.getText();
			String telnr = fieldTelefon.getText();			
			if (!vname.equals("") && !nname.equals("") && !telnr.equals("")) {
				adressbuch.kontaktHinzufuegen(fieldVorname.getText(), fieldNachname.getText(), fieldTelefon.getText());
				updateJList(adressbuch.getAdressbuch());
			}
		}
	}
	
	// fuer Button "Entfernen", ausgewaehlten Kontakt loeschen und JList updaten
	class EntfernenListener implements ActionListener {
		public void actionPerformed (ActionEvent event) {			
			Kontakt test = (Kontakt) list.getSelectedValue();
			adressbuch.kontaktLoeschen(test);
			if (fieldSuchen.getText() == "")
				updateJList(adressbuch.getAdressbuch());
			else // Suchfeld beruecksichtigen falls nicht leer
				updateJList(adressbuch.kontakteSuchen(fieldSuchen.getText()));		
		}
	}
	
	// fuer Suchfeld, die JList mit den gefundenen Kontakten updaten
	// wir muessen alle Methoden des Interface implementieren
	class SuchenListener implements KeyListener {
		public void keyPressed (KeyEvent event) {
		}
		public void keyReleased (KeyEvent event) {  // jeden Tastendruck abfangen
			updateJList(adressbuch.kontakteSuchen(fieldSuchen.getText()));
		}
		public void keyTyped (KeyEvent event) {
		}
	}
	
	// fuer JList, wenn ein Eintrag ausgewaehlt wird
	//class ListListener implements ListSelectionListener {
	//	public void valueChanged (ListSelectionEvent event) {
	//		if (!event.getValueIsAdjusting()) {
	//			System.out.println(list.getSelectedValue());
	//		}
	//	}	
	//}
	
	// fr JFrame, wenn das Fenster geschlossen wird
	// hiermit merken wir nicht, wenn das Programm ber das Men beendet wird !!!
	class BeendenListener implements WindowListener {
		public void windowOpened (WindowEvent e) {
		}
		public void windowActivated (WindowEvent e) {
		}
		public void windowClosed (WindowEvent e) {
		}
		public void windowClosing (WindowEvent e) {  // Kontakte speichern, wenn das Fenster geschlossen wird
			adressbuch.adressbuchSpeichern();
			System.out.println("Adressbuch wurde gespeichert");
		}
		public void windowDeactivated (WindowEvent e) {
		}
		public void windowDeiconified (WindowEvent e) {
		}
		public void windowIconified (WindowEvent e) {
		}
	}
}